<template>
    <v-layout row justify-center>
        <v-dialog v-model="dialogDataProp" width="600px" height="600px">
            <v-card>
                <v-card-title>
                    <span class="headline">Info de Paquete</span>
                </v-card-title>

                <v-card-text style="height: 500px;">
                    <v-form>
                        <v-container>

                            <v-layout column justify-center>

                                <v-flex xs12 sm12 md12 v-bind:class="{ 'error': listErrors.consigned_id }">
                                    <autocomplete
                                      :source="apiServer"
                                      v-model="consigned_id"
                                      placeholder="Clientes"
                                      results-property="items"
                                      :request-headers="authHeaders"
                                      :results-display="formattedDisplay">
                                    </autocomplete>
                                    <span v-if="listErrors.consigned_id"> {{ listErrors.consigned_id }} </span>
                                </v-flex>

                                <v-flex xs12 sm12 md12 v-bind:class="{ 'error': listErrors.paquetes }">
                                    <v-text-field v-model="paquetes" type="number" label="Numero de paquetes" required></v-text-field>
                                    <span v-if="listErrors.consigned_id"> {{ listErrors.consigned_id }} </span>
                                </v-flex>

                              <v-flex xs12 sm12 md12>
                                <autocomplete
                                  :source="apiServer2"
                                  v-model="load_id"
                                  placeholder="Paquete de:"
                                  results-property="items"
                                  :request-headers="authHeaders"
                                  :results-display="formattedDisplay"
                                >
                                </autocomplete>
                                <span class="error" v-if="listErrors.load_id"> {{ listErrors.load_id }} </span>
                              </v-flex>

                                <v-flex xs12 sm12 md12>
                                    <v-textarea name="input-7-1" label="Anotaciones" v-model="anotaciones">
                                    </v-textarea>
                                </v-flex>

                                <upload-image v-model="image" />

                            </v-layout>

                        </v-container>
                    </v-form>

                </v-card-text>

                <v-divider></v-divider>

                <v-card-actions>
                    <v-spacer></v-spacer>
                    <v-btn color="error" flat @click="closeDialog">
                        Cerrar
                    </v-btn>

                    <v-btn color="primary" flat @click="updateData">
                        Ingresar
                    </v-btn>
                </v-card-actions>
            </v-card>
        </v-dialog>
        <v-snackbar v-model="snackbar" bottom="bottom" :timeout="timeout">
            {{ message }}
            <v-btn flat @click="snackbar = false">
                Close
            </v-btn>

        </v-snackbar>
    </v-layout>
</template>

<script>
import Autocomplete from 'vuejs-auto-complete'
import UploadImage from '../UploadImage'
import Axios from 'axios';
import server from '../../server'

export default {
    props: {
        dialog: Boolean
    },
    components: {
        Autocomplete,
        UploadImage,
    },
    data: () => ({
        consigned_id: '',
        load_id: '',
        paquetes: 1,
        anotaciones: '',
        image: null,
        apiServer: `${server}/api/clientes?name=`,
        apiServer2:`${server}/api/loads?name=`,
        errors: false,
        listErrors: [],
        snackbar: false,
        message: '',
        timeout: 3000,
    }),
    methods: {
        clear() {
            this.listErrors = [];
            this.paquetes = 1;
            this.anotaciones = "";
            this.image = null;
        },

        closeDialog() {
            this.clear();
            this.$emit('close-dialog');
        },

        formattedDisplay(result) {
            return result.name
        },

        updateData() {

            //this.getLocation();
            const datos = {
                task_id: this.$route.params.id,
                consigned_id: this.consigned_id,
                load_id: this.load_id,
                paquetes: this.paquetes,
                anotacion: this.anotaciones,
                image: this.image,
                type: 2
            }

            Axios.post(`${server}/api/task/transportes-externos/store`, datos, {
                headers: {
                    Authorization: this.$store.getters.getAccessToken
                }

            }).then((res) => {
                this.message = "El registro fue actualizado correnctamente";
                this.$store.dispatch('setTaskTransportesExternosDetail', this.$route.params.id).then(() => {
                    this.closeDialog();
                    this.snackbar = true;
                });

            }).catch(errors => {
                if (errors.response) {
                    this.listErrors = errors.response.data.errors
                    this.$store.commit('showSnackbar', errors.response.data);
                    //this.$store.commit('SET_ERRORS', errors.response.data.errors)
                }

            })
        },
        getLocation() {
            this.$getLocation(options)
                .then(coordinates => {
                    console.log(coordinates);
                });
        },
    },
    computed: {
        dialogDataProp: {
            get: function () {
                return this.dialog
            },
            set() {}
        },

        authHeaders() {
            return {
                'Authorization': this.$store.getters.getAccessToken
            }
        },
    },
}
</script>

<style>
.dataName {
    padding-left: 1.5rem;
    font-size: 15px;
    font-weight: bold;
}
</style>
